#pragma once

#include "stdafx.h"

#include "GazeFactory.h"
#include "GazeCallbacks.h"
#include "ETUDCtrlDlg.h"
#include "ETUDListenerMessages.h"

#include "resource.h"

IGazeSinkControl* pSink;
CETUDCtrlDlg* statusDlg;

extern "C"
{


unsigned int __stdcall optionsThread(void* args)
{
	if (pSink != NULL)
		pSink->ShowOptions();

	return 0;
}

unsigned int __stdcall calibrateThread(void* args)
{
	if (pSink != NULL)
		pSink->Calibrate();
	
	return 0;
}

unsigned int __stdcall sourcesThread(void* args)
{
	if (pSink != NULL)
		pSink->ShowSources();
	
	return 0;
}

ETUDLISTENER_API void Initialize(sampleCallback samplecb, fixationCallback fixcb, blinkCallback blinkcb)
{
	pSink = GazeFactory::CreateETUDriverSink();
	pSink->RegisterSampleCallback(samplecb);
	pSink->RegisterBlinkCallback(blinkcb);
	pSink->RegisterFixationCallback(fixcb);
	
	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));
	if (statusDlg == NULL)
		statusDlg = new CETUDCtrlDlg();

	statusDlg->DoModal();

	return;
}

ETUDLISTENER_API void StartTracking()
{
	if (pSink != NULL)
		pSink->StartTracking();
}

ETUDLISTENER_API bool IsTracking()
{
	return (pSink != NULL)? pSink->IsTracking() : false;
}

ETUDLISTENER_API void StopTracking()
{
	if (pSink != NULL)
		pSink->StopTracking();
}

ETUDLISTENER_API void Options()
{
	_beginthreadex(NULL, 0, optionsThread, NULL, 0,NULL);
}

ETUDLISTENER_API void Calibrate()
{
	_beginthreadex(NULL, 0, calibrateThread, NULL, 0,NULL);
}

ETUDLISTENER_API void Source()
{
	_beginthreadex(NULL, 0, sourcesThread, NULL, 0,NULL);
}

ETUDLISTENER_API void RegisterBlinkCallback(blinkCallback callback)
{
	if (pSink != NULL)
		pSink->RegisterBlinkCallback(callback);
}

ETUDLISTENER_API void RegisterSampleCallback(sampleCallback callback)
{
	if (pSink != NULL)
		pSink->RegisterSampleCallback(callback);
}

ETUDLISTENER_API void RegisterFixationCallback(fixationCallback callback)
{
	if (pSink != NULL)
		pSink->RegisterFixationCallback(callback);
}

}