#pragma once

#include <vector>
#include "IGazeProcessor.h"
#include "GazeSink.h"
#include "ETUDriverSink.h"

class CETUDriverSinkWrapper : IGazeProcessor, IGazeSinkControl /*GazeSink*/
{
public:
	CETUDriverSinkWrapper(void);
	~CETUDriverSinkWrapper(void);

protected:
	void InitializeSink();
	void FinalizeSink();

public:
	/*IGazeSource members*/
	void StartTracking();
	void StopTracking();
	bool IsTracking();

	void ShowOptions();
	void ShowSources();
	void Calibrate();
		
	void RegisterBlinkCallback(blinkCallback callback);
	void RegisterSampleCallback(sampleCallback callback);
	void RegisterFixationCallback(fixationCallback callback);

	void UnRegisterBlinkCallback(blinkCallback callback);
	void UnRegisterSampleCallback(sampleCallback callback);
	void UnRegisterFixationCallback(fixationCallback callback);

	/*IGazeProcessor members*/
	void ProcessBlink(SiETUDBlink blink);
	void ProcessSample(SiETUDSample sample);
	void ProcessFixation(SiETUDFixation fixation);

protected:
	CETUDriverSink* pSink;
	blinkCallback mbcb;
	sampleCallback mscb;
	fixationCallback mfcb;

private:
/*	static unsigned int __stdcall optionsThread(void* args);
	static unsigned int __stdcall calibrateThread(void* args);
	static unsigned int __stdcall sourcesThread(void* args);*/
};

