#pragma once

#include "GazeCallbacks.h"

class GazeSink
{
public:
	virtual void StartTracking() = 0;
	virtual void StopTracking() = 0;
	virtual bool IsTracking() = 0;

	virtual void ShowOptions() = 0;
	virtual void ShowSources() = 0;
	virtual void Calibrate() = 0;
	
	virtual void RegisterBlinkCallback(blinkCallback callback) = 0;
	virtual void RegisterSampleCallback(sampleCallback callback) = 0;
	virtual void RegisterFixationCallback(fixationCallback callback) = 0;
};

class IGazeSinkControl
{
public:
	/*Control sink*/
	virtual void StartTracking() = 0;
	virtual void StopTracking() = 0;
	virtual void Calibrate() = 0;
	virtual bool IsTracking() = 0;

	/*Sink settings*/
	virtual void ShowOptions() = 0;
	virtual void ShowSources() = 0;
	
	/*Register/unregister callbacks*/
	virtual void RegisterBlinkCallback(blinkCallback callback) = 0;
	virtual void RegisterSampleCallback(sampleCallback callback) = 0;
	virtual void RegisterFixationCallback(fixationCallback callback) = 0;

	virtual void UnRegisterBlinkCallback(blinkCallback callback) = 0;
	virtual void UnRegisterSampleCallback(sampleCallback callback) = 0;
	virtual void UnRegisterFixationCallback(fixationCallback callback) = 0;
};